namespace lask{
    public struct feld{
        public int id;
        public int jahr;
        public string name;
        public string art;
        public string frucht;
        public string vorfrucht;
        public double groesse;
        public double pacht;
        public double dungn;
        public double dungp;
        public double dungk;
        public double dungm;
        public double dungs;
        public double dungc;
    }
    
    public struct aktion{
        public int id;
        public int feld;
        public string aktion;
        public DateTime datum;
        public double[] kosten;
        public psMittel[] psMittel;
        public string par1;
        public string par2;
        public double par3;
        public double par4;
        public double par5;
        public double par6;
        public double par7;
        public double par8;
        public double par9;
        public int bbch;
        public int schalter;
        public double flaeche;
        public string kommentar;
        public string anwender; 
    }
    
    public struct mittel{
        public int id;
        public string feldid;
        public int jahr;
        public int art;
        public string name;
        public string par3;
        public double par4;
        public double par5;
        public double par6;
        public double par7;
        public double par8;
        public double par9;
    }
    
    public struct druckdaten{
        public feld druckfeld;
        public aktion[] druckaktionen;
    }

    public struct psMittel{
    //Pflantenschutzmittel
        public string mittel;
        public string art;
        public double menge;
        
        public string to_string(){
        //Als string für Datenbank ausgeben
            return mittel + "|" + art + "|" + doubleparse(menge, 3);
        }
        public psMittel.from_string(string str){
        //Aus string erzeugen
            if (str.split("|").length == 3){
                mittel = str.split("|")[0];
                art = str.split("|")[1];
                menge = double.parse(str.split("|")[2]);
            }else{
                err(_("psMittel hat zu wenig Einträge"));
            }
        }
    }

    
public string doubleparse(double dble, int nk=2){
    string wert;
	string rueckwert;
    int minus = 0;
    
    if(dble <= -1){
        minus = 1;
        wert = GLib.Math.round(0 - (dble * (Math.pow(10, nk)))).to_string();
    }else{
        wert = GLib.Math.round(dble * (Math.pow(10, nk))).to_string();
    }
	if(wert.length <= nk-1){
		wert = GLib.Math.round(dble * (Math.pow(10, nk + 1))).to_string();
		wert += string.nfill(nk - wert.length, '0');
		rueckwert = wert.splice(-nk, -nk, "0,");
	}else if(wert.length == nk){
		rueckwert = wert.splice(-nk, -nk, "0,");
	}else{
		rueckwert = wert.splice(-nk, -nk, ",");
	}
	if(nk == 0){
		rueckwert= GLib.Math.round(dble).to_string();
	}
    if(minus == 1){
        rueckwert = "-" + rueckwert;
    }
	return rueckwert;
}
    
    public void err(string message="", int stufe=1){
        if(debuging == 1){
            string[] art = {_("Meldung"),
                            _("Fehler")};
            print(art[stufe] +": " + message + "\n");
        }
    }
    
    public string datum_berechnen(string d){
    //Sinnvolles Datum aus d bilden    
        string datum = d + "          ";
        
        if (int.parse(datum) <= 0){
            datum = new DateTime.now_local().add_days(int.parse(datum)).format("%d.%m.%Y");
        }else if (int.parse(datum[0:2]) <= 31 && int.parse(datum[3:5]) <= 12 && int.parse(datum[6:10]) <= erntejahr + 1){
            datum = new DateTime.local(int.parse("20" + datum[-12:-10]),int.parse(datum[3:5]),int.parse(datum[0:2]),0,0,0).format("%d.%m.%Y");
        }else{
            datum = new DateTime.now_local().format("%d.%m.%Y");
        }
    return datum;
    }
}
