using Sqlite;
using Gtk;
using lask;

const string localePfad = config.INSTALL_PATH + "/share/locale";
const string GETTEXT_PACKAGE = "lask";
const string version = "0.6.1";

TreeIter iter;
string datenVerzeichnis;
string uiVerzeichnis;
string datei;
int erntejahr=1;
int debuging=0;
cstartFenster startFenster;
chauptFenster hauptFenster;
cmittelFenster mittelFenster;
cfelderFenster felderFenster;
canlegenFenster anlegenFenster;
cbetriebEdit betriebEdit;
cmittelEdit mittelEdit;
cfeldEdit feldEdit;
caktionEdit aktionEdit;
causwertungUebersicht auswertungUebersicht;
causwertungNaehrstoff auswertungNaehrstoff;
claskDb laskDb;

feld betrieb;
feld aktFeld;
aktion aktAktion;
feld[] felderliste;
feld[] aktFelderListe;

public static int main (string[] args) {
    //Nach *.ui Dateien suchen
    #if Linux
            if(File.new_for_path(Path.get_dirname(FileUtils.read_link("/proc/self/exe"))+"/ui").query_file_type(0) == FileType.DIRECTORY){
                uiVerzeichnis = Path.get_dirname(FileUtils.read_link("/proc/self/exe"))+"/ui";
            }else if(File.new_for_path(config.INSTALL_PATH +"/share/lask/ui").query_file_type(0) == FileType.DIRECTORY){
                uiVerzeichnis = config.INSTALL_PATH + "/share/lask/ui";
            }else{
                print("FEHLER! Verzeichnis mit den ui-Dateien konnte nicht gefunden werden");
                return 1;
            }
            Environment.set_current_dir(uiVerzeichnis);
    #elif Windows
                uiVerzeichnis = Environment.get_system_data_dirs()[Environment.get_system_data_dirs().length-2] + "\\lask\\ui";
                Environment.set_current_dir(uiVerzeichnis + "\\lask\\ui");
    #endif
    //i18n Zeugs
    Intl.setlocale(LocaleCategory.MESSAGES, "");
    Intl.textdomain(GETTEXT_PACKAGE); 
    Intl.bind_textdomain_codeset(GETTEXT_PACKAGE, "utf-8");
    Intl.bindtextdomain(GETTEXT_PACKAGE, localePfad);
    aktFeld = feld();
    aktAktion = aktion();

    foreach (string arg in args){
        if(arg == "--debug"){debuging=1;}
        if(arg == "--help"){
            stdout.printf(_(
"""Aufruf: lask [Option]
Ackerschlagkartei für Linux

Optionen:
  --debug     gibt Debugmeldungen aus
  --version   zeigt die aktuelle Versionsnummer an
  --help      zeigt diese Hilfeseite an
"""));
            return 0;
        }
        if(arg == "--version"){
            print(_("LASK Version = " + version + "\n"));
            return 0;
        }
    }
    //Wenn Datenverzeichnis nicht da ist, dann erzeugen
    datenVerzeichnis = Environment.get_user_config_dir() + "/LASK/";
    if(File.new_for_path(datenVerzeichnis).query_file_type(0) != FileType.DIRECTORY){
        if(File.new_for_path(datenVerzeichnis).query_exists()){
            err(datenVerzeichnis + _(" ist kein Verzeichnis!"), 1);
            return 1;
        }
        File.new_for_path (datenVerzeichnis).make_directory_with_parents(null);
        err(_("Ordner `" + datenVerzeichnis + "' wurde angelegt: ") + datenVerzeichnis);
    }
    //Wenn Datenverzeichnis leer ist, dann Musterbetrieb reinkopieren
    if(File.new_for_path(datenVerzeichnis).enumerate_children("standard::*", FileQueryInfoFlags.NONE).next_file() == null){
        err(_("Musterbetrieb wurde angelegt"));
        if(File.new_for_path(uiVerzeichnis + "../Musterbetrieb.lask").query_exists()){
            File.new_for_path(uiVerzeichnis + "../Musterbetrieb.lask").copy(File.new_for_path(datenVerzeichnis + "/Musterbetrieb.lask"), 0, null);
        }else{
            err(_("Vorlage für Musterbetrieb nicht gefunden"), 1);
        }
    }

    Gtk.init (ref args);
    startFenster = new cstartFenster();
    laskDb= new claskDb();
    startFenster.window1.show_all();
    Gtk.main ();
    return 0;
}


public void feldInfo2(){
    TreeSelection selection;
    GLib.Value wert;
    TreeModel model;
    
    aktFeld.groesse = 0;
    aktFeld.id = -1;
    felderliste.resize(0);
    aktFelderListe.resize(0);
    selection = hauptFenster.treeview2.get_selection();
    var rows = selection.get_selected_rows(out model);
    felderliste = laskDb.felderLesen(erntejahr);
    foreach (feld f in felderliste){
        foreach(TreePath a in rows){
            model.get_iter(out iter, a);
            model.get_value(iter, 0, out wert);
            if (wert.get_int() == f.id){
                aktFelderListe += f;
                aktFeld.groesse += f.groesse;
            }
        }   
        if (aktFelderListe.length == 1){aktFeld = aktFelderListe[0];}
    }
}

public aktion aktionInfo(int feld){
    aktion rueckAktion = aktion();
    TreeSelection selection;
    GLib.Value wert;
    TreeModel model;
    
    rueckAktion.id = -1;
    selection = hauptFenster.treeview3.get_selection();
    selection.get_selected(out model, out iter);
    model.get_value(iter, 0, out wert);
    foreach (aktion a in laskDb.aktionLesen(feld.to_string(), erntejahr)){
            if (wert.get_int() == a.id){
                rueckAktion = a;
            }
    }
    return rueckAktion;
}

